#!/usr/bin/env python
# -*- coding: utf-8 -*-
# $Name:  $
import sys
import datetime
import matplotlib
matplotlib.use('TkAgg')
import Tkinter as Tk
import tkFileDialog as fd
from matplotlib.backends.backend_tkagg import FigureCanvasTkAgg, NavigationToolbar2TkAgg
from matplotlib.figure import Figure
import warnings
warnings.filterwarnings("ignore", category=UserWarning, module="matplotlib")
warnings.filterwarnings("ignore", category=FutureWarning, module="scipy")
import os
import csv
import threading

chn = [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1]
tab = -1
titolo = ""
titoloS = ""
fileTab = ''

btnAbi = 1

def disegna():
    global btnAbi

    btnAbi = 0
    labAtt.config(text='Creazione grafico...', bg = 'red', fg = 'white')
    t = threading.Thread(target=disegnaGrafico)
    t.start()

def disegnaGrafico():
    global titolo
    global tab
    global chn
    global btnAbi

    x = [None]*len(tab[0])

    i = 0
    for dati in tab[0]:
        x[i] = i*0.000864
        i = i+1

    if tab != -1:

        f.subplots_adjust(top=0.89, bottom=0.06, right=0.97, left=0.05)

        a.clear()
        b.clear()
        i = 0
        for col in tab:

            if chn[i]:
                if i == 0:
                    a.plot(col, 'b', label = 'current1')
                elif i == 1:
                    a.plot(col, 'g', label = 'RF2dir')
                elif i == 2:
                    a.plot(col, 'r', label = 'RF3dir')
                elif i == 3:
                    a.plot(col, 'c', label = 'RF8dir')
                elif i == 4:
                    a.plot(col, 'm', label = 'RF9dir')
                elif i == 5:
                    a.plot(col, 'y', label = 'current2')
                elif i == 6:
                    a.plot(col, 'g--', label = 'RF2rev')
                elif i == 7:
                    a.plot(col, 'r--', label = 'RF3rev')
                elif i == 8:
                    a.plot(col, 'c--', label = 'RF8rev')
                elif i == 9:
                    a.plot(col, 'm--', label = 'RF9rev')
                elif i == 10:
                    a.plot(col, 'k', label = 'current3')
                elif i == 11:
                    a.plot(col, 'g:', label = 'RF2pick')
                elif i == 12:
                    a.plot(col, 'r:', label = 'RF3pick')
                elif i == 13:
                    a.plot(col, 'c:', label = 'RF8pick')
                elif i == 14:
                    a.plot(col, 'm:', label = 'RF9pick')
            i = i+1

        titoloF.set_text(titolo)
        b.plot(x, [0]*len(tab[0]),  alpha = 0)
        a.legend()
        b.set_xlabel("[millisecondi]")
        a.set_xlabel("[giri]")

        b.xaxis.tick_top()
        b.xaxis.set_label_position('top')

        canvas.draw()

    labAtt.config(text='', bg = root['bg'])
    btnAbi = 1

def getTitolo(nFile):
    global titolo
    global titoloS

    file_base_name = os.path.basename(nFile)
    anno = file_base_name[:4]
    mese = file_base_name[4:6]
    giorno = file_base_name[6:8]

    ora = file_base_name[9:11]
    minuto = file_base_name[11:13]
    secondo = file_base_name[13:15]

    data = "{0}/{1}/{2} - {3}:{4}:{5}".format(giorno, mese, anno, ora, minuto, secondo)

    titolo = "Analisi dati beamdump detector " + data
    titoloS = "Analisi_dati_beamdump_detector_" + data

def getTabella(perF):

    tabella = [[], [], [], [], [], [], [], [], [], [], [], [], [], [], []]

    with open(perF, 'r') as csvfile:
        f = csv.reader(csvfile)
        i = 0
        for row in f:
            if i > 2:
                j = 0
                for n in row:
                    tabella[j].append(int(n))
                    j = j+1
            i = i+1
    return tabella

class CustomToolbar(NavigationToolbar2TkAgg):

    def _init_toolbar(self):
        xmin, xmax = self.canvas.figure.bbox.intervalx
        height, width = 50, xmax-xmin
        Tk.Frame.__init__(self, master=self.window,
                          width=width, height=height,
                          borderwidth=2)

        self.update()  # Make axes menu

        self.bHome = self._Button( text="Ripristina", file="home",
                                   command=self.home)

        self.bBack = self._Button( text="Indietro", file="back",
                                   command = self.back)

        self.bForward = self._Button(text="Avanti", file="forward",
                                     command = self.forward)

        self.bPan = self._Button( text="Sposta", file="move",
                                  command = self.pan)

        self.bZoom = self._Button( text="Zoom",
                                   file="zoom_to_rect",
                                   command = self.zoom)

        self.bsave = self._Button( text="Salva nel log", file="filesave",
                                   command = self.save_figure)
        self.message = Tk.StringVar(master=self)
        self._message_label = Tk.Label(master=self, textvariable=self.message)
        self._message_label.pack(side=Tk.RIGHT)
        self.pack(side=Tk.BOTTOM, fill=Tk.X)

    def save_figure(self, *args):
        global titoloS

        self.canvas.print_figure("/tmp/" + titoloS)

        os.system("scp %s Web@elog.elettra.trieste.it:/cygdrive/h/NewElogBook/logbook/my_documents/my_pictures" % ("/tmp/" + titoloS + ".png"))
        os.system("wget -q -O - --proxy=off http://elog.elettra.trieste.it/InsertImageElettra.php?param1=%s" % (titoloS + ".png"))
        os.system("rm %s" % ("/tmp/" + titoloS + ".png"))

def on_key_event(event):
    pass

def _quit():
    root.quit()     # stops mainloop
    root.destroy()  # this is necessary on Windows

def _ridisegna():
    if (btnAbi == 1):
        global chn
        global tab
        disegna()

def _filtroRF2():
    if (btnAbi == 1):
        chn0.deselect()
        chn1.select()
        chn2.deselect()
        chn3.deselect()
        chn4.deselect()
        chn5.select()
        chn6.select()
        chn7.deselect()
        chn8.deselect()
        chn9.deselect()
        chn10.deselect()
        chn11.select()
        chn12.deselect()
        chn13.deselect()
        chn14.deselect()
        _updateChn()

def _filtroRF3():
    if (btnAbi == 1):
        chn0.deselect()
        chn1.deselect()
        chn2.select()
        chn3.deselect()
        chn4.deselect()
        chn5.select()
        chn6.deselect()
        chn7.select()
        chn8.deselect()
        chn9.deselect()
        chn10.deselect()
        chn11.deselect()
        chn12.select()
        chn13.deselect()
        chn14.deselect()
        _updateChn()

def _filtroRF8():
    if (btnAbi == 1):
        chn0.deselect()
        chn1.deselect()
        chn2.deselect()
        chn3.select()
        chn4.deselect()
        chn5.select()
        chn6.deselect()
        chn7.deselect()
        chn8.select()
        chn9.deselect()
        chn10.deselect()
        chn11.deselect()
        chn12.deselect()
        chn13.select()
        chn14.deselect()
        _updateChn()

def _filtroRF9():
    if (btnAbi == 1):
        chn0.deselect()
        chn1.deselect()
        chn2.deselect()
        chn3.deselect()
        chn4.select()
        chn5.select()
        chn6.deselect()
        chn7.deselect()
        chn8.deselect()
        chn9.select()
        chn10.deselect()
        chn11.deselect()
        chn12.deselect()
        chn13.deselect()
        chn14.select()
        _updateChn()

def _filtroDir():
    if (btnAbi == 1):
        chn0.deselect()
        chn1.select()
        chn2.select()
        chn3.select()
        chn4.select()
        chn5.select()
        chn6.deselect()
        chn7.deselect()
        chn8.deselect()
        chn9.deselect()
        chn10.deselect()
        chn11.deselect()
        chn12.deselect()
        chn13.deselect()
        chn14.deselect()
        _updateChn()

def _filtroRev():
    if (btnAbi == 1):
        chn0.deselect()
        chn1.deselect()
        chn2.deselect()
        chn3.deselect()
        chn4.deselect()
        chn5.select()
        chn6.select()
        chn7.select()
        chn8.select()
        chn9.select()
        chn10.deselect()
        chn11.deselect()
        chn12.deselect()
        chn13.deselect()
        chn14.deselect()
        _updateChn()

def _filtroPick():
    if (btnAbi == 1):
        chn0.deselect()
        chn1.deselect()
        chn2.deselect()
        chn3.deselect()
        chn4.deselect()
        chn5.select()
        chn6.deselect()
        chn7.deselect()
        chn8.deselect()
        chn9.deselect()
        chn10.deselect()
        chn11.select()
        chn12.select()
        chn13.select()
        chn14.select()
        _updateChn()

def _filtroAll():
    if (btnAbi == 1):
        chn0.select()
        chn1.select()
        chn2.select()
        chn3.select()
        chn4.select()
        chn5.select()
        chn6.select()
        chn7.select()
        chn8.select()
        chn9.select()
        chn10.select()
        chn11.select()
        chn12.select()
        chn13.select()
        chn14.select()
        _updateChn()

def _filtroNone():
    if (btnAbi == 1):
        chn0.deselect()
        chn1.deselect()
        chn2.deselect()
        chn3.deselect()
        chn4.deselect()
        chn5.deselect()
        chn6.deselect()
        chn7.deselect()
        chn8.deselect()
        chn9.deselect()
        chn10.deselect()
        chn11.deselect()
        chn12.deselect()
        chn13.deselect()
        chn14.deselect()
        _updateChn()

def _updateChn():
    global chn
    chn[0] = var0.get()
    chn[1] = var1.get()
    chn[2] = var2.get()
    chn[3] = var3.get()
    chn[4] = var4.get()
    chn[5] = var5.get()
    chn[6] = var6.get()
    chn[7] = var7.get()
    chn[8] = var8.get()
    chn[9] = var9.get()
    chn[10] = var10.get()
    chn[11] = var11.get()
    chn[12] = var12.get()
    chn[13] = var13.get()
    chn[14] = var14.get()

def tabOpenFile():
    global fileTab
    global tab

    tab = getTabella(fileTab)
    getTitolo(fileTab)
    labAtt.config(text = 'Creazione grafico...', bg = 'red', fg = 'white')
    disegnaGrafico()

def _openFile():
    global fileTab
    global btnAbi
    if (btnAbi == 1):
        FileBeamdump = fd.askopenfilename(initialdir='/home/elettra/monitor/beamdump')
        if FileBeamdump != '':
            btnAbi = 0
            labAtt.config(text = 'Caricamento dati...', bg ='red', fg = 'white')
            fileTab = FileBeamdump
            t = threading.Thread(target=tabOpenFile)
            t.start()

root = Tk.Tk()
root.wm_title("Analisi dati beam dump detector")

f = Figure(figsize=(12,6), dpi=100, facecolor=root["bg"])
titoloF = f.suptitle('')
a = f.add_subplot(111)
b = a.twiny()
a.plot()

canvas = FigureCanvasTkAgg(f, master=root)
canvas._tkcanvas.config(highlightthickness=0)
canvas.show()
toolbar = CustomToolbar( canvas, root )
toolbar.pack_forget()
toolbar.pack(side=Tk.BOTTOM, anchor=Tk.W)

canvas.get_tk_widget().pack(side=Tk.LEFT, fill=Tk.BOTH, expand=1)
canvas.mpl_connect('key_press_event', on_key_event)

btnDis = Tk.Button(master=root, text='Disegna', command=_ridisegna)
btnDis.pack(side=Tk.TOP, anchor=Tk.W)

var0 = Tk.IntVar()
chn0 = Tk.Checkbutton(master=root, text='current1', command=_updateChn, variable=var0)
chn0.select()
chn0.pack(side=Tk.TOP, anchor=Tk.W)

var1 = Tk.IntVar()
chn1 = Tk.Checkbutton(master=root, text='RF2dir', command=_updateChn, variable=var1)
chn1.select()
chn1.pack(side=Tk.TOP, anchor=Tk.W)

var2 = Tk.IntVar()
chn2 = Tk.Checkbutton(master=root, text='RF3dir', command=_updateChn, variable=var2)
chn2.select()
chn2.pack(side=Tk.TOP, anchor=Tk.W)

var3 = Tk.IntVar()
chn3 = Tk.Checkbutton(master=root, text='RF8dir', command=_updateChn, variable=var3)
chn3.select()
chn3.pack(side=Tk.TOP, anchor=Tk.W)

var4 = Tk.IntVar()
chn4 = Tk.Checkbutton(master=root, text='RF9dir', command=_updateChn, variable=var4)
chn4.select()
chn4.pack(side=Tk.TOP, anchor=Tk.W)

var5 = Tk.IntVar()
chn5 = Tk.Checkbutton(master=root, text='current2', command=_updateChn, variable=var5)
chn5.select()
chn5.pack(side=Tk.TOP, anchor=Tk.W)

var6 = Tk.IntVar()
chn6 = Tk.Checkbutton(master=root, text='RF2rev', command=_updateChn, variable=var6)
chn6.select()
chn6.pack(side=Tk.TOP, anchor=Tk.W)

var7 = Tk.IntVar()
chn7 = Tk.Checkbutton(master=root, text='RF3rev', command=_updateChn, variable=var7)
chn7.select()
chn7.pack(side=Tk.TOP, anchor=Tk.W)

var8 = Tk.IntVar()
chn8 = Tk.Checkbutton(master=root, text='RF8rev', command=_updateChn, variable=var8)
chn8.select()
chn8.pack(side=Tk.TOP, anchor=Tk.W)

var9 = Tk.IntVar()
chn9 = Tk.Checkbutton(master=root, text='RF9rev', command=_updateChn, variable=var9)
chn9.select()
chn9.pack(side=Tk.TOP, anchor=Tk.W)

var10 = Tk.IntVar()
chn10 = Tk.Checkbutton(master=root, text='current3', command=_updateChn, variable=var10)
chn10.select()
chn10.pack(side=Tk.TOP, anchor=Tk.W)

var11 = Tk.IntVar()
chn11 = Tk.Checkbutton(master=root, text='RF2pick', command=_updateChn, variable=var11)
chn11.select()
chn11.pack(side=Tk.TOP, anchor=Tk.W)

var12 = Tk.IntVar()
chn12 = Tk.Checkbutton(master=root, text='RF3pick', command=_updateChn, variable=var12)
chn12.select()
chn12.pack(side=Tk.TOP, anchor=Tk.W)

var13 = Tk.IntVar()
chn13 = Tk.Checkbutton(master=root, text='RF8pick', command=_updateChn, variable=var13)
chn13.select()
chn13.pack(side=Tk.TOP, anchor=Tk.W)

var14 = Tk.IntVar()
chn14 = Tk.Checkbutton(master=root, text='RF9pick', command=_updateChn, variable=var14)
chn14.select()
chn14.pack(side=Tk.TOP, anchor=Tk.W)

labelVoid = Tk.Label(root)
labelVoid.pack(side=Tk.TOP, anchor=Tk.W)

labelFltr = Tk.Label(root, text='Filtri:')
labelFltr.pack(side=Tk.TOP, anchor=Tk.W)

btnRF2 = Tk.Button(master=root, text='Solo RF2', command=_filtroRF2)
btnRF2.pack(side=Tk.TOP, anchor=Tk.W)

btnRF3 = Tk.Button(master=root, text='Solo RF3', command=_filtroRF3)
btnRF3.pack(side=Tk.TOP, anchor=Tk.W)

btnRF8 = Tk.Button(master=root, text='Solo RF8', command=_filtroRF8)
btnRF8.pack(side=Tk.TOP, anchor=Tk.W)

btnRF9 = Tk.Button(master=root, text='Solo RF9', command=_filtroRF9)
btnRF9.pack(side=Tk.TOP, anchor=Tk.W)

btnDir = Tk.Button(master=root, text='Solo dir', command=_filtroDir)
btnDir.pack(side=Tk.TOP, anchor=Tk.W)

btnRev = Tk.Button(master=root, text='Solo rev', command=_filtroRev)
btnRev.pack(side=Tk.TOP, anchor=Tk.W)

btnPick = Tk.Button(master=root, text='Solo pick', command=_filtroPick)
btnPick.pack(side=Tk.TOP, anchor=Tk.W)

btnAll = Tk.Button(master=root, text='Seleziona tutto', command=_filtroAll)
btnAll.pack(side=Tk.TOP, anchor=Tk.W)

btnNone = Tk.Button(master=root, text='Deseleziona tutto', command=_filtroNone)
btnNone.pack(side=Tk.TOP, anchor=Tk.W)

sep = Tk.Label(master=root)
sep.pack(side=Tk.TOP, anchor=Tk.W)

btnOpen = Tk.Button(master=root, text='Apri file', command=_openFile)
btnOpen.pack(side=Tk.TOP, anchor=Tk.W)

sep2 = Tk.Label(master=root)
sep2.pack(side=Tk.TOP, anchor=Tk.W)

labAtt = Tk.Label(master=root, text='', )
labAtt.pack(side=Tk.TOP, anchor=Tk.W)

def inizio():
    global tab
    global btnAbi

    tab = getTabella(sys.argv[1])
    getTitolo(sys.argv[1])
    labAtt.config(text='Creazione grafico...', bg = 'red', fg = 'white')
    disegnaGrafico()
    if len(sys.argv) > 2 and sys.argv[2] == "save":
        toolbar.save_figure()
    btnAbi = 1
    labAtt.config(text = '', bg = root['bg'])

if len(sys.argv) > 1 and os.path.isfile(sys.argv[1]):
    btnAbi = 0
    labAtt.config(text = 'Caricamento dati...', bg = 'red', fg = 'white')
    t = threading.Thread(target = inizio)
    t.start()

root.protocol("WM_DELETE_WINDOW", _quit)
root.mainloop()
